Index: app_externalivr.c
===================================================================
--- app_externalivr.c	(revision 117430)
+++ app_externalivr.c	(working copy)
@@ -379,7 +379,7 @@
 		if (!ser) {
 			goto exit;
 		} 
-		res = eivr_comm(chan, u, ser->fd, ser->fd, 0, pipe_delim_argbuf);
+		res = eivr_comm(chan, u, ser->fd, ser->fd, -1, pipe_delim_argbuf);
 	} else {
 	
 		if (pipe(child_stdin)) {
@@ -495,7 +495,7 @@
 		ast_chan_log(LOG_WARNING, chan, "Could not open stream to receive commands\n");
 		goto exit;
 	}
-	if(eivr_errors_fd) {  /* if opening a socket connection, error stream will not be used */
+	if(eivr_errors_fd > -1) {  /* if opening a socket connection, error stream will not be used */
  		if (!(eivr_errors = fdopen(eivr_errors_fd, "r"))) {
  			ast_chan_log(LOG_WARNING, chan, "Could not open stream to receive errors\n");
  			goto exit;
@@ -529,7 +529,7 @@
  		errno = 0;
  		exception = 0;
  
- 		rchan = ast_waitfor_nandfds(&chan, 1, waitfds, 2, &exception, &ready_fd, &ms);
+ 		rchan = ast_waitfor_nandfds(&chan, 1, waitfds, (eivr_errors_fd == -1) ? 1 : 2, &exception, &ready_fd, &ms);
  
  		if (!AST_LIST_EMPTY(&u->finishlist)) {
  			AST_LIST_LOCK(&u->finishlist);
